PAGE   58,132
TITLE Superbios Headparking Program
SUBTTL    9/15/87  75-000390-X0
;Headparking program for WD Superbios'. Will
;seek the heads 48 cylinders past the number
;of cylinders defined in the drive tables or
;defined under a dynamic format (663 on a
;615 cylinder drive).
;============================================
; Revision History
; Rev 1.0=X0 MV     Initial version
;============================================
IVFC      equ   21h
FCPRSTR   equ   9
FCKBIN    equ   1
FCTEND    equ   4ch
;============================================
ram    segment at 40h
       org 75h
       ram_drv_cnt  db ?
ram    ends
;============================================
code   segment para public 'CODE'
          assume cs:code,ds:data
          mov ax,data
          mov ds,ax               ;set up ds
          mov es,ax               ;set up es
          mov dx,offset MHELLO    ;point to hello mess.
          call PRSTR              ;print string
          push ds                 ;save data seg
          assume ds:ram           ;make ram reachable
          mov ax,ram
          mov ds,ax               ;set up ds
          mov al,ram_drv_cnt      ;get the drive count
          assume ds:data
          pop ds                  ;restore ds
          mov DRV_CNT,al          ;save drive count
          cmp al,0                ;see if any drives
          jne more                ;jump if so
          mov dx,offset MNDRVS    ;point to no drives mess.
          call PRSTR              ;print string
          call DMNOD              ;display nothing done mess.
          jmp EXIT                ;exit
more:
          mov RHDSD,0             ;clear status
          cmp al,2                ;test # of drives
          je two_drives           ;jump if two
C_only:
          mov dx,offset MPARKC    ;point to mess.
          call PRSTR              ;print string
          call YINPUT             ;get response
          je rd_C_prms            ;jump if yes
          mov dx,offset MNOD      ;point to mess.
          call PRSTR              ;print string
          jmp EXIT                ;exit
rd_C_prms:
          mov dx,80h              ;drive C
          mov di,offset DS:RCYLC  ;pointer to C's parms
          call RDPRMS             ;get and modify parms
                                  ;don't worry about errors,
                                  ;Read Parms won't return any
          jmp prk_C               ;go park drive C
two_drives:
          mov dx,offset MCDB      ;point to mess. to park C, D,
                                  ;or both
          call PRSTR              ;print string
          mov ah,FCKBIN           ;load function
          int IVFC                ;get keyboard response
          and al,4fh              ;upper case
          mov DRVFLG,al           ;store response
          cmp al,'C'              ;drive C?
          je C_only               ;jump if so
          cmp al,'D'
          jle rng_chk             ;less than or equal to 'D'
                                  ;we're O.K. so far
rng_chk_0:
          call DMNOD              ;else we're out of range
          jmp EXIT                ;exit
rng_chk:
          cmp al,'B'
          jl rng_chk_0            ;less than 'B' and we are also
                                  ;out of range
          mov dx,81h              ;otherwise we are going to park
                                  ;at least drive D
          mov di,offset DS:RCYLD  ;pointer for D's parms
          call RDPRMS             ;get and modify parms
          cmp DRVFLG,'B'          ;see if both drives
          je both                 ;jump if so
          mov dx,offset MPARKD    ;else point to park D mess.
          call PRSTR              ;print string
          call YINPUT             ;get user response
          je prk_D                ;jump if yes
          call DMNOD              ;else display nothing done
          jmp EXIT                ;and exit
both:
          mov dx,80h              ;drive C
          mov di,offset DS:RCYLC  ;pointer to C's parms
          call RDPRMS             ;get and modify parms
          mov dx,offset MPARKCD   ;point to mess. to park C & D
          call PRSTR              ;print string
          call YINPUT             ;get user response
          je prk_D                ;jump if yes
          call DMNOD              ;else display nothing done mess.
          jmp EXIT                ;then exit
prk_D:
          mov dx,81h              ;drive D
          mov cx,RCYLD            ;cyl # for drive D
          mov bx,offset DS:RCYLD  ;set up bx for Int 13 call
          call PRKHDS             ;set parms and seek
          jc error_D              ;jump if error
          mov dx,offset MPRKD     ;point to drive D parked mess.
          call PRSTR              ;print string
          jmp tst_drv_flg         ;go see if we need to park C
error_D:
          mov dx,offset MERRORD   ;point to error mess.
          call PRSTR              ;print string
          mov RHDSD,0ffh          ;set error status
tst_drv_flg:
          cmp DRVFLG,'B'          ;park both drive?
          jne chk_sts             ;jump if not
prk_C:
          mov dx,80h              ;drive C
          mov cx,RCYLC            ;cyl # for drive C
          mov bx,offset DS:RCYLC  ;set up bx for Int 13 call
          call PRKHDS             ;set parms and seek
          jc error_C              ;jump if error
          mov dx,offset MPRKC     ;point to drvie C parked mess.
          call PRSTR              ;print string
          jmp chk_sts             ;see what the status for D is
error_C:
          mov dx,offset MERRORC   ;point to error mess.
          call PRSTR              ;print string
          mov RHDSD,0ffh          ;set error status
chk_sts:
          mov bh,1                ;set errorlevel for Int 21 exit
          mov al,0ffh
          cmp al,RHDSD            ;see if error status
          je EXIT                 ;exit if so
          mov dx,offset MPWRDN    ;else point to power down mess.
          call PRSTR              ;print string
          xor bh,bh               ;clear errorlevel
EXIT:
          mov ah,FCTEND           ;load function
          int IVFC                ;terminate
;================================================================
PRSTR:
          mov ah,FCPRSTR          ;load function
          int IVFC                ;print string
          ret
;================================================================
YINPUT:
          mov ah,FCKBIN           ;load function
          int IVFC                ;get keyboard input
          and al,5fh              ;upper case
          cmp al,'Y'              ;set return status
          ret
;================================================================
DMNOD:
          xor bh,bh               ;clear errorlevel for Int 21
          mov dx,offset MNOD      ;point to nothing done mess.
          call PRSTR              ;print string
          ret
;=======================================================
; READ PARAMETERS ROUTINE
; 1. Does a Read Parameters
; 2. Adds 51 to cyl # returned by read parms
; 3. Sets the new parameters into RAM
; Entry: DX with dirve #, DI pointing to RAM
; Exit: new parameters in RAM
;=======================================================
RDPRMS:
          mov ax,801h             ;read parms, cnt 1
          mov cx,01               ;cyl 0, sector 1
          int 13h                 ;Read Parameters
          mov ax,cx               ;packed cyl #
          mov cl,6                ;shift count
          shr al,cl               ;align two MSB's
          xchg ah,al              ;ax=cyl #
          mov cx,51d              ;value to add
          add ax,cx
          cmp ax,1024d            ;see if within range
          jle cyl_ok              ;jump if O.K
          mov ax,1024d            ;else force to max
cyl_ok:
          mov [di],ax             ;load # of cyl in RAM
          inc dh                  ;update # of heads returned
                                  ;by read parms
          add di,2                ;update pointer
          mov [di],dh             ;load # of heads in RAM
          add di,7                ;update pointer
          mov [di],ax             ;load virtual cyl #
          ret

;=================================================
; HEADPARKING ROUTINE
; 1. Does external Set Parameters
; 2. Seeks to cyl # returned by Read Parms plus 50
; Entry: DX with drive #, CX with modified cyl #
;        ES:BX pointing to parameter table
; Exit: Heads parked or carry flag set
;=================================================
PRKHDS:
          mov ax,1601h            ;load command
          int 13h                 ;Set Ext. Parms
          jc rtrnprk              ;jump if error
          sub cx,1                ;cyl to seek to
          mov ax,cx               ;unpacked cyl #
          mov cl,6                ;shift count
          xchg ah,al              ;repack cyl #
          shl al,cl               ;align two MSB's
          or al,1                 ;sector 1
          mov cx,ax               ;load cyl #
          mov ax,0c01h            ;seek, cnt of 1
          int 13h                 ;SEEK
rtrnprk:  ret
code      ends

data      segment
MHELLO    db 0dh,0ah,'**** Headparking program for the Western Digital '
          db 'Superbios. ****',0dh,0ah,'       ver. 1.0 (c) Copyright '
          db 'Western Digital Corp. 1987.',0dh,0ah,0ah
          db 'This program will seek the heads 48 cylinders past the'
          db 0dh,0ah,'number of cylinders defined in the drive '
          db 'tables or defined ',0dh,0ah,'under a dynamic format (e.g. 663'
          db ' on a 615 cylinder drive).$'
MPARKC    db 0dh,0ah,0ah,'Press "y" to park the heads on drive C, any other'
          db ' key to exit.$'
MPARKD    db 0dh,0ah,0ah,'Press "y" to park the heads on drive D, any other'
          db ' key to exit.$'
MCDB      db 0dh,0ah,0ah,'Would you like to park the heads on drive C (c), '
          db 'D (d), or Both (b)?$'
MPARKCD   db 0dh,0ah,0ah,'Press "y" to park the heads on drive C and D, any'
          db ' other key to exit.$'
MPRKC     db 0dh,0ah,0ah,'Heads have been parked, drive C.$'
MPRKD     db 0dh,0ah,0ah,'Heads have been parked, drive D.$'
MPWRDN    db 0dh,0ah,0ah,'Please power down.',0ah,'$'
MERRORC   db 0dh,0ah,0ah,'Error detected on drive C, heads may not be'
          db ' parked.$'
MERRORD   db 0dh,0ah,0ah,'Error detected on drive D, heads may not be'
          db ' parked.$'
MNOD      db 0dh,0ah,'Nothing done, returning to DOS.',0ah,'$'
MNDRVS    db 0dh,0ah,0ah,'No drives to park!',0ah,'$'

          RCYLC dw ?              ;RAM reserved for drive
          RHDSC db ?              ;C's parameters
          RRWCC dw -1
          RWPCC dw -1
          RECLC db 0bh
          RCCBC db 6
          RVCYLC dw ?

          RCYLD dw ?              ;RAM reserved for drive
          RHDSD db ?              ;D's parameters
          RRWCD dw -1
          RWPCD dw -1
          RECLD db 0bh
          RCCBD db 6
          RVCYLD dw ?

          DRV_CNT db ?            ;drive count storage
          DRVFLG  db ?            ;flag for which drives to park
data      ends
          end

